using System;

/// <summary>
///		Summary description for mailadm_login_settings.
/// </summary>
public partial class loginLite_settings : System.Web.UI.UserControl
{

    public string clientPrefix;
    protected void Page_Load(object sender, System.EventArgs e)
	{
		// Put user code to initialize the page here

        clientPrefix = this.ClientID;
        
        WebMailLite.WebmailSettings settings = new WebMailLite.WebmailSettings().CreateInstance(Utils.GetWebMailDataFolder());
        
        if (!Page.IsPostBack)
		{
			switch (settings.HideLoginMode)
			{
                case WebMailLite.LoginMode.Default:
					standartLoginRadio.Checked = true;
					break;
                case WebMailLite.LoginMode.HideLoginFieldLoginIsEmail:
					hideLoginRadio.Checked = true;
					hideLoginSelect.SelectedIndex = 0;
					break;
                case WebMailLite.LoginMode.HideLoginFieldLoginIsAccount:
					hideLoginRadio.Checked = true;
					hideLoginSelect.SelectedIndex = 1;
					break;
                case WebMailLite.LoginMode.HideEmailField:
					hideEmailRadio.Checked = true;
					break;
                case WebMailLite.LoginMode.HideEmailFieldDisplayDomainAfterLogin:
					hideEmailRadio.Checked = true;
					intDisplayDomainAfterLoginField.Checked = true;
					break;
                case WebMailLite.LoginMode.HideEmailFieldLoginIsLoginAndDomain:
					hideEmailRadio.Checked = true;
					intLoginAsConcatination.Checked = true;
					break;
                case WebMailLite.LoginMode.HideEmailFieldDisplayDomainAfterLoginAndLoginIsLoginAndDomain:
					hideEmailRadio.Checked = true;
					intDisplayDomainAfterLoginField.Checked = true;
					intLoginAsConcatination.Checked = true;
					break;
				default:
                    goto case WebMailLite.LoginMode.Default;
			}
			txtUseDomain.Value = settings.DefaultDomainOptional;

			intAllowAdvancedLogin.Checked = settings.AllowAdvancedLogin;
			intAutomaticCorrectLogin.Checked = settings.AutomaticCorrectLoginSettings;
		}
		else
		{
			Trace.Write("Login settings is postback");
		}
	}

	#region Web Form Designer generated code
	override protected void OnInit(EventArgs e)
	{
		//
		// CODEGEN: This call is required by the ASP.NET Web Form Designer.
		//
		InitializeComponent();
		base.OnInit(e);
	}

	/// <summary>
	///		Required method for Designer support - do not modify
	///		the contents of this method with the code editor.
	/// </summary>
	private void InitializeComponent()
	{

	}
	#endregion

	protected void SaveButton_Click(object sender, System.EventArgs e)
	{
		try
		{
            WebMailLite.WebmailSettings settings = new WebMailLite.WebmailSettings().CreateInstance(Utils.GetWebMailDataFolder());
            
            if (standartLoginRadio.Checked)
			{
                settings.HideLoginMode = WebMailLite.LoginMode.Default;
			}
			else if (hideLoginRadio.Checked)
			{
				if (hideLoginSelect.SelectedIndex == 0)
				{
                    settings.HideLoginMode = WebMailLite.LoginMode.HideLoginFieldLoginIsEmail;
				}
				else
				{
                    settings.HideLoginMode = WebMailLite.LoginMode.HideLoginFieldLoginIsAccount;
				}
			}
			else
			{
				if ((intDisplayDomainAfterLoginField.Checked) && (intLoginAsConcatination.Checked))
				{
                    settings.HideLoginMode = WebMailLite.LoginMode.HideEmailFieldDisplayDomainAfterLoginAndLoginIsLoginAndDomain;
				}
				else if (intDisplayDomainAfterLoginField.Checked)
				{
                    settings.HideLoginMode = WebMailLite.LoginMode.HideEmailFieldDisplayDomainAfterLogin;
				}
				else if (intLoginAsConcatination.Checked)
				{
                    settings.HideLoginMode = WebMailLite.LoginMode.HideEmailFieldLoginIsLoginAndDomain;
				}
				else
				{
                    settings.HideLoginMode = WebMailLite.LoginMode.HideEmailField;
				}
			}
			settings.DefaultDomainOptional = txtUseDomain.Value;

			settings.AllowAdvancedLogin = intAllowAdvancedLogin.Checked;
			settings.AutomaticCorrectLoginSettings = intAutomaticCorrectLogin.Checked;

			settings.SaveWebmailSettings(Utils.GetWebMailDataFolder());

            Utils.SetPageReportMessage(this.Page, WebMailLite.Constants.mailAdmSaveSuccess);
		}
		catch (Exception)
		{
            Utils.SetPageErrorMessage(this.Page, WebMailLite.Constants.mailAdmSaveUnsuccess);
		}
	}
}
