using System;

namespace WebMailLite
{
	/// <summary>
	/// Summary description for Constants.
	/// </summary>
	public class Constants
	{
		protected Constants() {}

		//TODO: add constants to lang file-------
		public const string ntwStreamNull = "Network stream is null.";
		public const string wmServCmdNull = "WMServer command is null.";
		//---------------------------------------

		public static DateTime MinDate = new DateTime(1970, 1, 1);

		public const string mailadmLogin = "mailadm";
		public const string appSettingsDataFolderPath = "dataFolderPath";
		public const string mailFolderName = "Mail";
		public const string tempFolderName = "Temp";
		public const string logFilename = "log.txt";
		public const string defaultSkinName = "Hotmail_Style";
		public const string nonChangedPassword = "77u/ZG9t";
		public const int PathMaxLength = 248;
		public const int DownloadChunk = 50;
		public const string defaultLang = "English";
		public const string webmailTab = "wm.tab";

		public const string sessionAccount = "account";
		public const string sessionTempFolder = "temp_folder";
		public const string sessionSettings = "webmail_settings";
		public const string sessionReportText = "report_text";

		public const string mailAdmSaveSuccess = "Save successful!";
		public const string mailAdmSaveUnsuccess = "Save unsuccessful!";
		public const string mailAdmConnectSuccess = "Connect successful!";
		public const string mailAdmConnectUnsuccess = "Connect unsuccessful!";
		public const string mailAdmTablesExists = "Some tables exist. You must rename or remove it.";
		public const string mailAdmTablesCreated = "Tables created!";
		public const string mailAdmTablesNotCreated = "Creating table error!";
		public const string mailAdmLogClearSuccess = "Log clear successful!";
		public const string mailAdmLogClearUnsuccess = "Log clear error!";
		public const string mailAdmUpdateAccountSuccess = "Update successful!";
		public const string mailAdmUpdateAccountUnsuccess = "Update unsuccessful!";
		public const string mailAdmCreateAccountSuccess = "Create successful!";
		public const string mailAdmCreateAccountUnsuccess = "Create unsuccessful!";

		public struct DateFormats
		{
			public const string Default = "default";
			public const string DDMMYY = "dd/mm/yy";
			public const string MMDDYY = "mm/dd/yy";
			public const string DDMonth = "dd month";
		}

		public struct SupportedLangs
		{
			public const string English = "English";
			public const string French = "French";
			public const string Catala = "Catal";
			public const string Espanyol = "Espanyol";
			public const string Nederlands = "Nederlands";
			public const string Swedish = "Swedish";
			public const string Turkish = "Turkish";
			public const string German = "German";
			public const string Portuguese = "Portuguese";
			public const string Italiano = "Italiano";
		}

		public struct MailDirStruct
		{
			public const string Cur = "cur";
			public const string New = "new";
			public const string Tmp = "tmp";
		}

		public struct StaticScreenNames
		{
			public const string new_message = "new_message";
			public const string _default = "default";
			public const string mail_list = "mail_list";
			public const string message = "message";
		}

		public static string[] Charsets = {
												   "CharsetDefault",
												   "CharsetArabicAlphabetISO",
												   "CharsetArabicAlphabet",
												   "CharsetBalticAlphabetISO",
												   "CharsetBalticAlphabet",
												   "CharsetCentralEuropeanAlphabetISO",
												   "CharsetCentralEuropeanAlphabet",
												   "CharsetChineseTraditional",
												   "CharsetCyrillicAlphabetISO",
												   "CharsetCyrillicAlphabetKOI8R",
												   "CharsetCyrillicAlphabet",
												   "CharsetGreekAlphabetISO",
												   "CharsetGreekAlphabet",
												   "CharsetHebrewAlphabetISO",
												   "CharsetHebrewAlphabet",
												   "CharsetJapanese",
												   "CharsetJapaneseShiftJIS",
												   "CharsetKoreanEUC",
												   "CharsetKoreanISO",
												   "CharsetLatin3AlphabetISO",
												   "CharsetTurkishAlphabet",
												   "CharsetUniversalAlphabetUTF7",
												   "CharsetUniversalAlphabetUTF8",
												   "CharsetVietnameseAlphabet",
												   "CharsetWesternAlphabetISO",
												   "CharsetWesternAlphabet"
											   };

		public static string[] PageName = {
											  "-1",
											  "iso-8859-6",
											  "windows-1256",
											  "iso-8859-4",
											  "windows-1257",
											  "iso-8859-2",
											  "windows-1250",
											  "big5",
											  "iso-8859-5",
											  "koi8-r",
											  "windows-1251",
											  "iso-8859-7",
											  "windows-1253",
											  "iso-8859-8",
											  "windows-1255",
											  "iso-2022-jp",
											  "shift-jis",
											  "euc-kr",
											  "iso-2022-kr",
											  "iso-8859-3",
											  "windows-1254",
											  "utf-7",
											  "utf-8",
											  "windows-1258",
											  "iso-8859-1",
											  "windows-1252"
										  };

		public static int[] PageNumber = {
											  -1,
											  28596,
											  1256,
											  28594,
											  1257,
											  28592,
											  1250,
											  950,
											  28595,
											  20866,
											  1251,
											  28597,
											  1253,
											  28598,
											  1255,
											  50220,
											  932,
											  946,
											  50225,
											  28593,
											  1254,
											  65000,
											  65001,
											  1258,
											  28591,
											  1252
										  };

		public struct WebmailTabKeys
		{
			public const string ControlPort = "CtrlPort";
			public const string SmtpPort = "SmtpPort";
			public const string Login = "Login";
			public const string Pass = "Password";
		}
	}
}

