using System;
using System.Configuration;
using System.Globalization;
using System.IO;
using System.Text;
using System.Web.UI;
using System.Xml;
using System.Xml.Serialization;
using System.Xml.XPath;
using System.Collections;

namespace WebMailLite
{
	/// <summary>
	/// Summary description for SettingsManagement.
	/// </summary>
	[Serializable]
	public class WebmailSettings
	{
		#region Fields
		protected WebmailSettings _instance;

		protected string _siteName;
		protected string _licenseKey;
		protected string _adminPassword;
/*
		protected SupportedDatabase _dbType;
		protected string _dbLogin;
		protected string _dbPassword;
		protected string _dbName;
		protected string _dbDsn;
		protected string _dbHost;
		protected string _dbPathToMdb;
		protected bool _useCustomConnectionString;
		protected string _dbCustomConnectionString;
		protected string _dbPrefix;
*/
		protected IncomingMailProtocol _incomingMailProtocol;
		protected string _incomingMailServer;
		protected int _incomingMailPort;
		protected string _outgoingMailServer;
		protected int _outgoingMailPort;
		protected bool _reqSmtpAuth;
		protected bool _allowAdvancedLogin;
		protected LoginMode _hideLoginMode;
		protected string _defaultDomainOptional;
		protected bool _showTextLabels;
		protected bool _automaticCorrectLoginSettings;
		protected bool _enableLogging;
//		protected bool _disableErrorHandling;
		protected bool _allowAjax;
		protected short _mailsPerPage;
		protected long _attachmentSizeLimit;
		protected bool _enableAttachmentSizeLimit;
		protected long _mailboxSizeLimit;
		protected bool _enableMailboxSizeLimit;
		protected short _defaultTimeOffset;
//		protected bool _allowUsersChangeTimeOffset;
		protected int _defaultUserCharset;
//		protected bool _allowUsersChangeCharset;
		protected string _defaultSkin;
//		protected bool _allowUsersChangeSkin;
		protected string _defaultLanguage;
/*
		protected bool _allowUsersChangeLanguage;
		protected bool _allowDhtmlEditor;
		protected bool _allowUsersChangeEmailSettings;
		protected bool _allowDirectMode;
		protected bool _directModeIsDefault;
		protected bool _allowNewUserRegister;
		protected bool _allowUsersAddNewAccount;
		protected bool _storeMailsInDb;
*/
		protected bool _enableWmServer;
		protected string _wmServerRootPath;
        protected string _wmServerHost;
		protected ViewMode _viewMode;

		private Hashtable _webmailTab;

		#endregion

		#region Properties

		public string SiteName
		{
            get { return _siteName; }
            set { _siteName = value; }
		}

		public string LicenseKey
		{
			get { return _licenseKey; }
			set { _licenseKey = value; }
		}

		public string AdminPassword
		{
			get { return _adminPassword; }
			set { _adminPassword = value; }
		}
/*
		public SupportedDatabase DbType
		{
			get { return _dbType; }
			set { _dbType = value; }
		}

		public string DbLogin
		{
			get { return _dbLogin; }
			set { _dbLogin = value; }
		}

		public string DbPassword
		{
			get { return _dbPassword; }
			set { _dbPassword = value; }
		}

		public string DbName
		{
			get { return _dbName; }
			set { _dbName = value; }
		}

		public string DbDsn
		{
			get { return _dbDsn; }
			set { _dbDsn = value; }
		}

		public string DbHost
		{
			get { return _dbHost; }
			set { _dbHost = value; }
		}

		public string DbPathToMdb
		{
			get { return _dbPathToMdb; }
			set { _dbPathToMdb = value; }
		}

		public bool UseCustomConnectionString
		{
			get { return _useCustomConnectionString; }
			set { _useCustomConnectionString = value; }
		}

		public string DbCustomConnectionString
		{
			get { return _dbCustomConnectionString; }
			set { _dbCustomConnectionString = value; }
		}

		public string DbPrefix
		{
			get { return _dbPrefix; }
			set { _dbPrefix = value; }
		}
*/
		public IncomingMailProtocol IncomingMailProtocol
		{
			get { return _incomingMailProtocol; }
			set { _incomingMailProtocol = value; }
		}

		public string IncomingMailServer
		{
			get { return _incomingMailServer; }
			set { _incomingMailServer = value; }
		}

		public int IncomingMailPort
		{
			get { return _incomingMailPort; }
			set { _incomingMailPort = value; }
		}

		public string OutgoingMailServer
		{
			get { return _outgoingMailServer; }
			set { _outgoingMailServer = value; }
		}

		public int OutgoingMailPort
		{
			get { return _outgoingMailPort; }
			set { _outgoingMailPort = value; }
		}

		public bool ReqSmtpAuth
		{
			get { return _reqSmtpAuth; }
			set { _reqSmtpAuth = value; }
		}

		public bool AllowAdvancedLogin
		{
			get { return _allowAdvancedLogin; }
			set { _allowAdvancedLogin = value; }
		}

		public LoginMode HideLoginMode
		{
			get { return _hideLoginMode; }
			set { _hideLoginMode = value; }
		}

		public string DefaultDomainOptional
		{
			get { return _defaultDomainOptional; }
			set { _defaultDomainOptional = value; }
		}

		public bool ShowTextLabels
		{
			get { return _showTextLabels; }
			set { _showTextLabels = value; }
		}

		public bool AutomaticCorrectLoginSettings
		{
			get { return _automaticCorrectLoginSettings; }
			set { _automaticCorrectLoginSettings = value; }
		}

		public bool EnableLogging
		{
			get { return _enableLogging; }
			set { _enableLogging = value; }
		}
/*
		public bool DisableErrorHandling
		{
			get { return _disableErrorHandling; }
			set { _disableErrorHandling = value; }
		}
*/
		public bool AllowAjax
		{
			get { return _allowAjax; }
			set { _allowAjax = value; }
		}

		public short MailsPerPage
		{
			get { return _mailsPerPage; }
			set { _mailsPerPage = value; }
		}

		public long AttachmentSizeLimit
		{
			get { return _attachmentSizeLimit; }
			set { _attachmentSizeLimit = value; }
		}

		public bool EnableAttachmentSizeLimit
		{
			get { return _enableAttachmentSizeLimit; }
			set { _enableAttachmentSizeLimit = value; }
		}

		public long MailboxSizeLimit
		{
			get { return _mailboxSizeLimit; }
			set { _mailboxSizeLimit = value; }
		}

		public bool EnableMailboxSizeLimit
		{
			get { return _enableMailboxSizeLimit; }
			set { _enableMailboxSizeLimit = value; }
		}

		public short DefaultTimeZone
		{
			get { return _defaultTimeOffset; }
			set { _defaultTimeOffset = value; }
		}
/*
		public bool AllowUsersChangeTimeZone
		{
			get { return _allowUsersChangeTimeOffset; }
			set { _allowUsersChangeTimeOffset = value; }
		}
*/
		public int DefaultUserCharset
		{
			get { return _defaultUserCharset; }
			set { _defaultUserCharset = value; }
		}
/*
		public bool AllowUsersChangeCharset
		{
			get { return _allowUsersChangeCharset; }
			set { _allowUsersChangeCharset = value; }
		}
*/
		public string DefaultSkin
		{
			get { return _defaultSkin; }
			set { _defaultSkin = value; }
		}
/*
		public bool AllowUsersChangeSkin
		{
			get { return _allowUsersChangeSkin; }
			set { _allowUsersChangeSkin = value; }
		}
*/
		public string DefaultLanguage
		{
			get { return _defaultLanguage; }
			set { _defaultLanguage = value; }
		}
/*
		public bool AllowUsersChangeLanguage
		{
			get { return _allowUsersChangeLanguage; }
			set { _allowUsersChangeLanguage = value; }
		}

		public bool AllowDhtmlEditor
		{
			get { return _allowDhtmlEditor; }
			set { _allowDhtmlEditor = value; }
		}

		public bool AllowUsersChangeEmailSettings
		{
			get { return _allowUsersChangeEmailSettings; }
			set { _allowUsersChangeEmailSettings = value; }
		}

		public bool AllowDirectMode
		{
			get { return _allowDirectMode; }
			set { _allowDirectMode = value; }
		}

		public bool DirectModeIsDefault
		{
			get { return _directModeIsDefault; }
			set { _directModeIsDefault = value; }
		}

		public bool AllowNewUsersRegister
		{
			get { return _allowNewUserRegister; }
			set { _allowNewUserRegister = value; }
		}

		public bool AllowUsersAddNewAccounts
		{
			get { return _allowUsersAddNewAccount; }
			set { _allowUsersAddNewAccount = value; }
		}

		public bool StoreMailsInDb
		{
			get { return _storeMailsInDb; }
			set { _storeMailsInDb = value; }
		}
*/
		public bool EnableWmServer
		{
			get { return _enableWmServer; }
			set { _enableWmServer = value; }
		}

		public string WmServerRootPath
		{
			get { return _wmServerRootPath; }
			set { _wmServerRootPath = value; }
		}

        public string WmServerHost
		{
            get { return _wmServerHost; }
            set { _wmServerHost = value; }
		}

		public ViewMode Mode
		{
			get { return _viewMode; }
			set { _viewMode = value; }
		}

		protected Hashtable WebmailTab
		{
			get { return _webmailTab; }
		}

		public int XMailControlPort
		{
			get
			{
				int port = 0;
				if (_webmailTab != null)
				{
					if (_webmailTab[Constants.WebmailTabKeys.ControlPort] != null)
					{
						if (int.TryParse(_webmailTab[Constants.WebmailTabKeys.ControlPort].ToString(), out port))
						{
							return port;
						}
					}
				}
				return port;
			}
		}

		public int XMailSmtpPort
		{
			get
			{
				int port = 0;
				if (_webmailTab != null)
				{
					if (_webmailTab[Constants.WebmailTabKeys.SmtpPort] != null)
					{
						if (int.TryParse(_webmailTab[Constants.WebmailTabKeys.SmtpPort].ToString(), out port))
						{
							return port;
						}
					}
				}
				return port;
			}
		}

		public string XMailLogin
		{
			get
			{
				if (_webmailTab != null)
				{
					return (string)_webmailTab[Constants.WebmailTabKeys.Login];
				}
				return null;
			}
		}

		public string XMailPass
		{
			get
			{
				if (_webmailTab != null)
				{
					return WMServerStorage.DecryptPassword((string)_webmailTab[Constants.WebmailTabKeys.Pass]);
				}
				return null;
			}
		}
		#endregion

		public WebmailSettings()
		{
			_instance = null;

			_siteName = string.Empty;
			_licenseKey = string.Empty;
			_adminPassword = string.Empty;
			_incomingMailServer = string.Empty;
			_incomingMailPort = 110;
			_outgoingMailServer = string.Empty;
			_outgoingMailPort = 25;
			_reqSmtpAuth = true;
			_allowAdvancedLogin = true;
			_hideLoginMode = LoginMode.Default;
			_defaultDomainOptional = string.Empty;
			_showTextLabels = true;
			_automaticCorrectLoginSettings = true;
			_enableLogging = true;
			_allowAjax = true;
			_mailsPerPage = 20;
			_attachmentSizeLimit = 10000000;
			_enableAttachmentSizeLimit = true;
			_mailboxSizeLimit = 9000000;
			_enableMailboxSizeLimit = true;
			_defaultTimeOffset = 0;
			_defaultUserCharset = Encoding.Default.CodePage;
			_defaultSkin = Constants.defaultSkinName;
			_defaultLanguage = Constants.SupportedLangs.English;
			_viewMode = ViewMode.AlwaysShowPictures;

            _enableWmServer = false;
            _wmServerRootPath = "";
            _wmServerHost = "";
		}

        public WebmailSettings CreateInstance()
        {
            if (_instance == null)
            {
                _instance = new WebmailSettings();
                _instance.LoadWebmailSettings();
            }

            return _instance;
        }

        public WebmailSettings CreateInstance(string dataFolder)
        {
            if (_instance == null)
            {
                _instance = new WebmailSettings();
                _instance.LoadWebmailSettings(dataFolder);
            }

            return _instance;
        }

        public void _LoadXML(XmlNode root)
        {
            for (int i = 0; i < root.ChildNodes.Count; i++)
            {
                XmlNode node = root.ChildNodes[i];
                switch (node.Name)
                {
                    case "SiteName":
                        this.SiteName = node.InnerText;
                        break;
                    case "WindowTitle":
                        this.SiteName = node.InnerText;
                        break;
                    case "AdminPassword":
                        this.AdminPassword = node.InnerText;
                        break;
                    case "IncomingMailProtocol":
                        if (node.InnerText != string.Empty) this.IncomingMailProtocol = (IncomingMailProtocol)int.Parse(node.InnerText);
                        break;
                    case "IncomingMailServer":
                        this.IncomingMailServer = node.InnerText;
                        break;
                    case "IncomingMailPort":
                        if (node.InnerText != string.Empty) this.IncomingMailPort = int.Parse(node.InnerText);
                        break;
                    case "OutgoingMailServer":
                        this.OutgoingMailServer = node.InnerText;
                        break;
                    case "OutgoingMailPort":
                        if (node.InnerText != string.Empty) this.OutgoingMailPort = int.Parse(node.InnerText);
                        break;
                    case "ReqSmtpAuth":
                        this.ReqSmtpAuth = (string.Compare(node.InnerText, "1", true, CultureInfo.InvariantCulture) == 0) ? true : false;
                        break;
                    case "AllowAdvancedLogin":
                        this.AllowAdvancedLogin = (string.Compare(node.InnerText, "1", true, CultureInfo.InvariantCulture) == 0) ? true : false;
                        break;
                    case "HideLoginMode":
                        this.HideLoginMode = (LoginMode)short.Parse(node.InnerText, CultureInfo.InvariantCulture);
                        break;
                    case "DefaultDomainOptional":
                        this.DefaultDomainOptional = node.InnerText;
                        break;
                    case "ShowTextLabels":
                        this.ShowTextLabels = (string.Compare(node.InnerText, "1", true, CultureInfo.InvariantCulture) == 0) ? true : false;
                        break;
                    case "AutomaticCorrectLoginSettings":
                        this.AutomaticCorrectLoginSettings = (string.Compare(node.InnerText, "1", true, CultureInfo.InvariantCulture) == 0) ? true : false;
                        break;
                    case "EnableLogging":
                        this.EnableLogging = (string.Compare(node.InnerText, "1", true, CultureInfo.InvariantCulture) == 0) ? true : false;
                        break;
                    case "AllowAjax":
                        this.AllowAjax = (string.Compare(node.InnerText, "1", true, CultureInfo.InvariantCulture) == 0) ? true : false;
                        break;
                    case "MailsPerPage":
                        if (node.InnerText != string.Empty) this.MailsPerPage = short.Parse(node.InnerText);
                        break;
                    case "EnableAttachmentSizeLimit":
                        this.EnableAttachmentSizeLimit = (string.Compare(node.InnerText, "1", true, CultureInfo.InvariantCulture) == 0) ? true : false;
                        break;
                    case "AttachmentSizeLimit":
                        if (node.InnerText != string.Empty) this.AttachmentSizeLimit = long.Parse(node.InnerText);
                        break;
                    case "EnableMailboxSizeLimit":
                        this.EnableMailboxSizeLimit = (string.Compare(node.InnerText, "1", true, CultureInfo.InvariantCulture) == 0) ? true : false;
                        break;
                    case "MailboxSizeLimit":
                        if (node.InnerText != string.Empty) this.MailboxSizeLimit = long.Parse(node.InnerText);
                        break;
                    case "DefaultUserCharset":
                        if (node.InnerText != string.Empty) this.DefaultUserCharset = int.Parse(node.InnerText);
                        break;
                    case "DefaultSkin":
                        this.DefaultSkin = node.InnerText;
                        break;
                    case "DefaultLanguage":
                        this.DefaultLanguage = node.InnerText;
                        break;
                    case "ViewMode":
                        this.Mode = (ViewMode)short.Parse(node.InnerText, CultureInfo.InvariantCulture);
                        break;
                    case "EnableWmServer":
                        this.EnableWmServer = (string.Compare(node.InnerText, "1", true, CultureInfo.InvariantCulture) == 0) ? true : false;
                        break;
                    case "WmServerRootPath":
                        this.WmServerRootPath = node.InnerText;
                        break;
                    case "WmServerHost":
                        this.WmServerHost = node.InnerText;
                        break;
                }
            }
        }

        public void LoadWebmailSettings()
        {
            LoadWebmailSettings(Utils.GetDataFolderPath());
        }

        public void LoadWebmailSettings(string dataFolder)
        {
            try
            {
                string filename = Path.Combine(dataFolder, @"Settings\settings.xml");
                XmlDocument doc = new XmlDocument();
                doc.Load(filename);
                XmlNode root = doc.DocumentElement;
                _LoadXML(root);
                _webmailTab = Utils.ReadWebmailTab(this.WmServerRootPath);
				this.LicenseKey = "MNWL";
			}
            catch (Exception ex)
            {
                throw new WebMailSettingsException(ex);
            }
        }

        public void SaveWebmailSettings()
        {
            SaveWebmailSettings(Utils.GetDataFolderPath());
        }

        public void SaveWebmailSettings(string dataFolder)
		{
			try
			{
                string filename = Path.Combine(dataFolder, @"Settings\settings.xml");

				XmlDocument result = new XmlDocument();
				result.PreserveWhitespace = false;
				XmlDeclaration xmlDecl = result.CreateXmlDeclaration("1.0", "utf-8", "");
				result.AppendChild(xmlDecl);
				
				XmlElement settingsElem = result.CreateElement("Settings");
				result.AppendChild(settingsElem);

				XmlElement subElem = result.CreateElement("SiteName");
				subElem.AppendChild(result.CreateTextNode(this.SiteName));
				settingsElem.AppendChild(subElem);

				subElem = result.CreateElement("AdminPassword");
				subElem.AppendChild(result.CreateTextNode(this.AdminPassword));
				settingsElem.AppendChild(subElem);

				subElem = result.CreateElement("IncomingMailProtocol");
				subElem.AppendChild(result.CreateTextNode(((int)this.IncomingMailProtocol).ToString(CultureInfo.InvariantCulture)));
				settingsElem.AppendChild(subElem);

				subElem = result.CreateElement("IncomingMailServer");
				subElem.AppendChild(result.CreateTextNode(this.IncomingMailServer));
				settingsElem.AppendChild(subElem);

				subElem = result.CreateElement("IncomingMailPort");
				subElem.AppendChild(result.CreateTextNode(this.IncomingMailPort.ToString(CultureInfo.InvariantCulture)));
				settingsElem.AppendChild(subElem);

				subElem = result.CreateElement("OutgoingMailServer");
				subElem.AppendChild(result.CreateTextNode(this.OutgoingMailServer));
				settingsElem.AppendChild(subElem);

				subElem = result.CreateElement("OutgoingMailPort");
				subElem.AppendChild(result.CreateTextNode(this.OutgoingMailPort.ToString(CultureInfo.InvariantCulture)));
				settingsElem.AppendChild(subElem);

				subElem = result.CreateElement("ReqSmtpAuth");
				subElem.AppendChild(result.CreateTextNode((this.ReqSmtpAuth) ? "1" : "0"));
				settingsElem.AppendChild(subElem);

				subElem = result.CreateElement("AllowAdvancedLogin");
				subElem.AppendChild(result.CreateTextNode((this.AllowAdvancedLogin) ? "1" : "0"));
				settingsElem.AppendChild(subElem);

				subElem = result.CreateElement("HideLoginMode");
				subElem.AppendChild(result.CreateTextNode(((short)this.HideLoginMode).ToString(CultureInfo.InvariantCulture)));
				settingsElem.AppendChild(subElem);

				subElem = result.CreateElement("DefaultDomainOptional");
				subElem.AppendChild(result.CreateTextNode(this.DefaultDomainOptional));
				settingsElem.AppendChild(subElem);

				subElem = result.CreateElement("ShowTextLabels");
				subElem.AppendChild(result.CreateTextNode((this.ShowTextLabels) ? "1" : "0"));
				settingsElem.AppendChild(subElem);

				subElem = result.CreateElement("AutomaticCorrectLoginSettings");
				subElem.AppendChild(result.CreateTextNode((this.AutomaticCorrectLoginSettings) ? "1" : "0"));
				settingsElem.AppendChild(subElem);

				subElem = result.CreateElement("EnableLogging");
				subElem.AppendChild(result.CreateTextNode((this.EnableLogging) ? "1" : "0"));
				settingsElem.AppendChild(subElem);

				subElem = result.CreateElement("AllowAjax");
				subElem.AppendChild(result.CreateTextNode((this.AllowAjax) ? "1" : "0"));
				settingsElem.AppendChild(subElem);

				subElem = result.CreateElement("MailsPerPage");
				subElem.AppendChild(result.CreateTextNode(this.MailsPerPage.ToString(CultureInfo.InvariantCulture)));
				settingsElem.AppendChild(subElem);

				subElem = result.CreateElement("AttachmentSizeLimit");
				subElem.AppendChild(result.CreateTextNode(this.AttachmentSizeLimit.ToString(CultureInfo.InvariantCulture)));
				settingsElem.AppendChild(subElem);

				subElem = result.CreateElement("EnableAttachmentSizeLimit");
				subElem.AppendChild(result.CreateTextNode((this.EnableAttachmentSizeLimit) ? "1" : "0"));
				settingsElem.AppendChild(subElem);

				subElem = result.CreateElement("MailboxSizeLimit");
				subElem.AppendChild(result.CreateTextNode(this.MailboxSizeLimit.ToString(CultureInfo.InvariantCulture)));
				settingsElem.AppendChild(subElem);

				subElem = result.CreateElement("EnableMailboxSizeLimit");
				subElem.AppendChild(result.CreateTextNode((this.EnableMailboxSizeLimit) ? "1" : "0"));
				settingsElem.AppendChild(subElem);

				subElem = result.CreateElement("DefaultTimeZone");
				subElem.AppendChild(result.CreateTextNode(this.DefaultTimeZone.ToString(CultureInfo.InvariantCulture)));
				settingsElem.AppendChild(subElem);

				subElem = result.CreateElement("DefaultUserCharset");
				subElem.AppendChild(result.CreateTextNode(this.DefaultUserCharset.ToString(CultureInfo.InvariantCulture)));
				settingsElem.AppendChild(subElem);

				subElem = result.CreateElement("DefaultSkin");
				subElem.AppendChild(result.CreateTextNode(this.DefaultSkin));
				settingsElem.AppendChild(subElem);

				subElem = result.CreateElement("DefaultLanguage");
				subElem.AppendChild(result.CreateTextNode(this.DefaultLanguage));
				settingsElem.AppendChild(subElem);

				subElem = result.CreateElement("ViewMode");
				subElem.AppendChild(result.CreateTextNode(((int)this.Mode).ToString(CultureInfo.InvariantCulture)));
				settingsElem.AppendChild(subElem);

                subElem = result.CreateElement("EnableWmServer");
                subElem.AppendChild(result.CreateTextNode((this.EnableWmServer) ? "1" : "0"));
                settingsElem.AppendChild(subElem);

                subElem = result.CreateElement("WmServerRootPath");
                subElem.AppendChild(result.CreateTextNode(this.WmServerRootPath));
                settingsElem.AppendChild(subElem);

                subElem = result.CreateElement("WmServerHost");
                subElem.AppendChild(result.CreateTextNode(this.WmServerHost));
                settingsElem.AppendChild(subElem);

				result.Save(filename);

				_instance = null;
			}
			catch (Exception ex)
			{
				throw new WebMailSettingsException(ex);
			}
		}
	}

    public class WebMailSettingsCreator : Control
    {
        public WebmailSettings CreateWebMailSettings()
        {
            return CreateWebMailSettings(Utils.GetDataFolderPath());
        }

        public WebmailSettings CreateWebMailSettings(string dataFolder)
        {
            WebmailSettings newSettings = new WebmailSettings();
            if (this.Context.Application[Constants.sessionSettings] != null)
            {
                newSettings = (WebmailSettings)this.Context.Application[Constants.sessionSettings];
            }
            else
            {
                newSettings = newSettings.CreateInstance(dataFolder);
                this.Context.Application.Add(Constants.sessionSettings, newSettings);
            }
            return newSettings;
        }

		public void ResetWebMailSettings()
		{
			if (this.Context.Application[Constants.sessionSettings] != null)
			{
				this.Context.Application[Constants.sessionSettings] = null;
			}
		}
	}
}
