namespace WebMailLite.classic
{
	using System;
	using System.Data;
	using System.Drawing;
	using System.Web;
	using System.Web.UI.WebControls;
	using System.Web.UI.HtmlControls;

	/// <summary>
	///		Summary description for _Default.
	/// </summary>
	public class _Default : System.Web.UI.UserControl
	{
		protected WebMailLite.classic.Inbox _Control_Maillist;
		protected WebMailLite.classic.LowToolbar _Control_Lowtoolbar;

		protected string _skin = Constants.defaultSkinName;

		protected WebmailResourceManager _manager = null;
		protected Account _acct = null;

		public WebMailLite.classic.Inbox Control_Maillist
		{
			get { return _Control_Maillist; }
		}

		public WebMailLite.classic.LowToolbar Control_LowToolbar
		{
			get { return _Control_Lowtoolbar; }
		}

		public string Skin
		{
			get { return _skin; }
			set { _skin = value; }
		}

		protected jsbuilder _js;
		public jsbuilder js
		{
			get { return _js; }
			set { _js = value; }
		}

		private void Page_Load(object sender, System.EventArgs e)
		{
			WebmailSettings settings = (new WebMailSettingsCreator()).CreateWebMailSettings();
			_manager = (new WebmailResourceManagerCreator()).CreateResourceManager();

			_acct = Session[Constants.sessionAccount] as Account;

			Control_Maillist.JSBuilder = _js;

			_js.AddFile("classic/class_pageswitcher_classic.js");
            _js.AddFile("classic/class_selection.js");
			_js.AddFile("classic/class_maillist.js");

			JS_ResizeElements();
			JS_CheckThisLine();
			JS_Init();
		}

		protected void JS_Init()
		{
			if (_acct != Session[Constants.sessionAccount])
			{
				Session[Constants.sessionAccount] = _acct;
			}
			
			string AddInitText = @"
				PageSwitcher = new CPageSwitcher('" + _skin + @"');
				PageSwitcher.Build();

				MainContainer = new CMainContainer();
				MessagesBox = new CMessagesBox();
				
				HFPageInfo = document.getElementById(""HFPageInfo"");
				var tempArr = HFPageInfo.value.split(""----"");
				
				PageSwitcher.Show(tempArr[0]*1, tempArr[1]*1, tempArr[2]*1, ""Pager('"", ""');"");
				
				var m_message = document.getElementById(""messageBody"");
				var m_message_center = document.getElementById(""message_center"");	
			";

			_js.AddInitText(AddInitText);
		}

		protected void JS_CheckThisLine()
		{
			string AddText = @"
				function SwitchTo(mode)
				{
					HFAction = document.getElementById(""HFAction"");
					HFRequest = document.getElementById(""HFRequest"");
					
					HFAction.value = """";
					HFRequest.value = """";

					HFAction.value = ""switch"";
					if(mode == 1)
					{
						HFRequest.value = ""html"";
					}
					else
					{
						HFRequest.value = ""plain"";
					}
					
					__doPostBack('PostBackButton','');

				}			

				var _isLoadMessage = false;
				function LoadMessageFull(id)
				{
					_isLoadMessage = true;
					HFAction = document.getElementById(""HFAction"");
					HFRequest = document.getElementById(""HFRequest"");
					HFValue = document.getElementById(""HFValue"");
					
					HFAction.value = """";
					HFRequest.value = """";
					HFValue.value = """";

					HFAction.value = ""get"";
					HFRequest.value = ""message_full_screen"";

					HFValue.value = id;

					__doPostBack('PostBackButton','');
				}


				function LoadMessage(lineid)
				{
				}

				function CheckDbClick(id)
				{
					isTimerStart = false;
					if (ClickCount > 0) 
					{
						ClickCount = 0;
						
						var HFTempValue = document.getElementById(""HFValue"");
						if (HFTempValue.value != id)
						{
							HFTempValue.value = id;
							LoadMessage(id);
						}
					}
				}

				var ClickCount = 0;
				var isTimerStart = false;
				function CheckThisLine(e, trobj, type)
				{
					var id = trobj.id;

					e = e ? e : window.event;

					if (Browser.Mozilla) {var elem = e.target;}
					else {var elem = e.srcElement;}

					if (e.ctrlKey)
					{
						ClickCount = 0;
						InboxLines.CheckCtrlLine(id);
					} 
					else if (e.shiftKey) 
					{
						ClickCount = 0;
						InboxLines.CheckShiftLine(id);
					} 
					else
					{
							if (elem && elem.tagName.toLowerCase() == ""a"") {
								LoadMessageFull(id);
							} else if (elem && elem.tagName.toLowerCase() == ""input"") {
								InboxLines.CheckCBox(id);
							}
					}
				}

				function CheckThisLineDb(e, trobj)
				{
					var id = trobj.id;

					e = e ? e : window.event;

					if (Browser.Mozilla) {var elem = e.target;}
					else {var elem = e.srcElement;}

					if (!elem || id == """" || elem.id == ""none"" || elem.tagName.toLowerCase() == ""input"") 
					{
						return false;
					}
					LoadMessageFull(id);
				}

				function ChangeCharset()
				{
				}
				
				function Pager(id)
				{
					HFPageInfo = document.getElementById(""HFPageInfo"");
					
					HFPageInfo.value = """";

					HFPageInfo.value = ""m----"" + id;
					
					__doPostBack('PagerButton','');
				}

				function DoReplyButton()
				{
					var idsArray = InboxLines.GetCheckedLines();
					
					if(idsArray.IdArray.length > 0)
					{
						HFAction = document.getElementById(""HFAction"");
						HFRequest = document.getElementById(""HFRequest"");
						HFValue = document.getElementById(""HFValue"");
						
						HFAction.value = """";
						HFRequest.value = """";
						HFValue.value = """";

						HFAction.value = ""reply"";
						HFValue.value = idsArray.IdArray[0];

						__doPostBack('PostBackButton','');
					}
					else
					{
						alert(""" + _manager.GetString("WarningMarkListItem") + @""");
					}
				}

				function DoReplyAllButton()
				{
					var idsArray = InboxLines.GetCheckedLines();
					
					if(idsArray.IdArray.length > 0)
					{
						HFAction = document.getElementById(""HFAction"");
						HFRequest = document.getElementById(""HFRequest"");
						HFValue = document.getElementById(""HFValue"");
						
						HFAction.value = """";
						HFRequest.value = """";
						HFValue.value = """";

						HFAction.value = ""replyall"";
						HFValue.value = idsArray.IdArray[0];

						__doPostBack('PostBackButton','');
					}
					else
					{
						alert(""" + _manager.GetString("WarningMarkListItem") + @""");
					}
				}

				function DoForwardButton()
				{
					var idsArray = InboxLines.GetCheckedLines();
					
					if(idsArray.IdArray.length > 0)
					{
						HFAction = document.getElementById(""HFAction"");
						HFRequest = document.getElementById(""HFRequest"");
						HFValue = document.getElementById(""HFValue"");
						
						HFAction.value = """";
						HFRequest.value = """";
						HFValue.value = """";

						HFAction.value = ""forward"";
						HFValue.value = idsArray.IdArray[0];

						__doPostBack('PostBackButton','');
					}
					else
					{
						alert(""" + _manager.GetString("WarningMarkListItem") + @""");
					}
				}
				";

			_js.AddText(AddText);
		}

		protected void JS_ResizeElements()
		{
			string AddText = @"
				var MainContainer, MessagesBox;
				var PageSwitcher;
				var EmptyHtmlUrl = ""empty.html"";
				var WebMail = { _html: document.getElementById('html') };
				
				function ResizeElements(mode)
				{
					var height = GetHeight();
					var width = GetWidth();
					
					MainContainer.inner_height = height - 2 - MainContainer.getExternalHeight();
					
					if (MainContainer.inner_height < 300)
					{
						MainContainer.inner_height = 300;
					}
					
					if (mode != 'height') 
					{
						//width
						if (width < 600)
						{
							width = 600;
						} 
						MessagesBox.resizeElementsWidth(width, mode);
					}

					PageSwitcher.Replace(MessagesBox.list_table);
					SetBodyAutoOverflow(true);
				}

			";
			js.AddText(AddText);
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN: This call is required by the ASP.NET Web Form Designer.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		///		Required method for Designer support - do not modify
		///		the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.Load += new System.EventHandler(this.Page_Load);
		}
		#endregion
	}
}
