
function CSelectionPart(tr, skinName, messageObj)
{
	tr.onmousedown = function() {return false;}//don't select content in Opera
	tr.onselectstart = function() {return false;}//don't select content in IE
	tr.onselect = function() {return false;}//don't select content in IE
	this._tr = tr;
	this._className = tr.className;

	this.Id = tr.id;
	this.Checked = false;

	var collection = this._tr.getElementsByTagName('td');
	if (collection.length > 5)
	{
		this._checkTd = collection[0];
		var checkboxcoll = this._checkTd.getElementsByTagName('input');
		if (checkboxcoll.length > 0) {
				this._checkbox = checkboxcoll[0];
		}
		this._fromTd = collection[2];
		this._subjTd = collection[5];
	}

	this.MsgUid = messageObj.Uid;
	this.MsgFromAddr = messageObj.FromAddr;
	this.MsgSubject = messageObj.Subject;

	this.SetClassName();
	this.ApplyClassName();
}

CSelectionPart.prototype = {
	Check: function()
	{
		this.Checked = true;
		this.ApplyClassName();
		this.AppleCheckBox();
	},

	Uncheck: function()
	{
		this.Checked = false;
		this.ApplyClassName();
		this.AppleCheckBox();
	},
	
	SetClassName: function ()
	{
		this._className = 'wm_inbox_item';
	},
	
	ApplyClassName: function ()
	{
		if (this.Checked)
			this._tr.className = this._className + '_select';
		else
			this._tr.className = this._className;
	},
	
	AppleCheckBox: function ()
	{
		if (this._checkbox) this._checkbox.checked = (this.Checked);
	},
	
	ApplyFromSubj: function ()
	{
		this._fromTd.innerHTML = '<nobr>' + this.MsgFromAddr + '</nobr>';
		this._subjTd.innerHTML = '<nobr>' + this.MsgSubject + '</nobr>';
	}
}

function CSelection(skinName)
{
	this.lines = Array();
	this.length = 0;
	this.prev = -1;
	this._skinName = skinName;
	
	this.AllCheckBox = document.getElementById("allcheck");
	this.LinesObj = document.getElementById("list");
}

CSelection.prototype = 
{
	Fill: function  ()
	{
		var trCollection = this.LinesObj.getElementsByTagName('tr');
		var iCount = trCollection.length;
		for (var i=0; i<iCount; i++)
		{
			messObj = {Uid: trCollection[i].id, FromAddr: '', Subject: ''};
			this.AddLine(new CSelectionPart(trCollection[i], this._skinName , messObj));
		}
	},
	
	AddLine: function (line)
	{
		this.lines.push(line);
		this.length = this.lines.length;
	},
	
	ChangeLineId: function (msg, newId)
	{
		for (var i = this.length-1; i >= 0; i--) {
			var line = this.lines[i];
			if (line.MsgUid == msg.Uid) {
				line.Id = newId;
				line._tr.id = newId;
				line.MsgFromAddr = msg.FromAddr;
				line.MsgSubject = msg.Subject;
				line.ApplyFromSubj();
			}
		}
	},
	
	UpdateSubject: function(lineId, subj, from)
	{
		for (var i = this.length-1; i >= 0; i--) {
			var line = this.lines[i];
			if (line.Id == lineId) {
				line.MsgFromAddr = from;
				line.MsgSubject = subj;
				line.ApplyFromSubj();
			}
		}
	},
		
	GetCheckedLines: function ()
	{
		var idArray = Array();
		var unreaded = 0;
		for (var i = this.length-1; i >= 0; i--) {
			var line = this.lines[i];
			if (line.Checked == true) {
				idArray.push(line.Id);
			}
		}
		return {IdArray: idArray, Unreaded: unreaded};
	},
	
	GetCheckedLinesObj: function ()
	{
		var messArray = Array();
		for (var i = this.length-1; i >= 0; i--)
		{
			var line = this.lines[i];
			if (line.Checked == true) messArray.push(line);
		}
		return messArray;
	},
	
	GetLinesById: function (lineId)
	{
		for (var i = this.length-1; i >= 0; i--)
		{
			var line = this.lines[i];
			if (line.Id == lineId) return line;
		}
		return null;
	},
	
	CheckCtrlLine: function(id)
	{
		for (var i = this.length-1; i >= 0; i--) {
			var line = this.lines[i];
			if (line.Id == id){
				if (line.Checked == false) {
					line.Check();
					this.prev = i;
				} else {
					line.Uncheck();
				}
			}
		}
		this.ReCheckAllBox();
	},
	
	CheckLine: function(id)
	{
		for (var i = this.length-1; i >= 0; i--) {
			var line = this.lines[i];
			if (line.Id == id){
				line.Check();
				this.prev = i;
			} else {
				line.Uncheck();
			}
		}
		this.ReCheckAllBox();
	},
	
	DragItemsNumber: function (id)
	{
		var findLine = null;
		var number = 0;
		for (var i = this.length-1; i >= 0; i--) {
			var line = this.lines[i];
			if (line.Id == id){
				findLine = line;
			}
			if (line.Checked) {
				number++;
			}
		}
		if (null == findLine) {
			return 0;
		} else if (findLine.Checked) {
			return number;
		} else {
			this.CheckLine(id);
			return 1;
		}
	},
	
	CheckShiftLine: function(id)
	{
		if (this.prev == -1) {
			this.CheckLine(id);
		} else {
			var isChecking = false;
			var prev = this.prev;
			for (var i = 0; i < this.length; i++) {
				var line = this.lines[i];
				if (this.prev == i || line.Id == id)
					isChecking = isChecking ? false : true;
				if (line.Id == id)
					prev = i;
				if (isChecking || this.prev == i || line.Id == id) {
					line.Check();
				} else {
					line.Uncheck();
				}
			}
			//this.prev = prev;
		}
		this.ReCheckAllBox();
	},
	
	UncheckAll: function ()
	{
		for (var i = this.length-1; i >= 0; i--) {
			this.lines[i].Uncheck();
		}
		this.prev = -1;
	},
	
	ReCheckAllBox: function()
	{
		var isAllCheck = true;
		for (var i = this.length-1; i >= 0; i--) {
			if (this.lines[i].Checked == false) { isAllCheck = false;}
		}
		if (this.AllCheckBox)
		{
			this.AllCheckBox.checked = isAllCheck;
		}		
	},
	
	CheckCBox: function(id)
	{
		for (var i = this.length-1; i >= 0; i--) {
			var line = this.lines[i];
			if (line.Id == id){
				if (line.Checked == false) {
					line.Check();
					this.prev = i;
				} else {
					line.Uncheck();
				}
			}
		}

		this.ReCheckAllBox();
	},
		
	CheckAllbox: function(objCheckbox)
	{
		for (var i = this.length-1; i >= 0; i--) {
			var line = this.lines[i];
			if (objCheckbox.checked) {
				line.Check();
			} else {
				line.Uncheck();
			}
		}		
	}
}
