using System.Globalization;
using System.Text;
using MailBee.Mime;

namespace WebMailLite.classic
{
	using System;
	using System.Data;
	using System.Drawing;
	using System.Web;
	using System.Web.UI.WebControls;
	using System.Web.UI.HtmlControls;

	public enum MessageAction
	{
		New,
		Reply,
		ReplyAll,
		Forward
	}

	/// <summary>
	///		Summary description for newmessage.
	/// </summary>
	public class NewMessage : System.Web.UI.UserControl
	{

		protected WebmailResourceManager _resMan = null;
		protected string _skin = Constants.defaultSkinName;
		protected bool _acceptFlag = false;
		protected MessageAction _action = MessageAction.New;
		protected MailMessage _message = null;
		protected string body = string.Empty;
		protected string attachmentsHtml = string.Empty;
		protected System.Web.UI.HtmlControls.HtmlInputText fromTextBox;
		protected System.Web.UI.HtmlControls.HtmlInputText toTextBox;
		protected System.Web.UI.HtmlControls.HtmlInputText ccTextBox;
		protected System.Web.UI.HtmlControls.HtmlInputText bccTextBox;
		protected System.Web.UI.HtmlControls.HtmlInputText subjectTextBox;
		
		protected jsbuilder _js;
		public jsbuilder js
		{
			get { return _js; }
			set { _js = value; }
		}
		public string Skin
		{
			get { return _skin; }
			set { _skin = value; }
		}

		public bool AcceptFlag
		{
			get {return _acceptFlag;}
			set {_acceptFlag = value;}
		}

		public MessageAction Action
		{
			get { return _action; }
			set { _action = value; }
		}

		public MailMessage Message
		{
			get { return _message; }
			set { _message = value; }
		}

		private void Page_Load(object sender, System.EventArgs e)
		{
			_resMan = (new WebmailResourceManagerCreator()).CreateResourceManager();
			
			Account acct = Session[Constants.sessionAccount] as Account;

			string getTo = Request.QueryString["to"] as string;
			if (getTo != null && getTo.Length > 0)
			{
				toTextBox.Value = getTo;
			}

			if (acct != null)
			{
				this.fromTextBox.Value = acct.Email;

				js.AddInitText(@"
	plainEditor = document.getElementById('editor_area');
	bccMode = 'hide';
	bccCont = document.getElementById('bcc');
	bccSwitcher = document.getElementById('bcc_mode_switcher');
");

				js.AddText(@"

	var bccCont, bccMode, bccSwitcher;
	var hiddenform;
	var plainEditor = null;
	var prevWidth = 0;
	var prevHeight = 0;
	var rowIndex = 0;

	function ResizeElements(mode)
	{
		ResizeAll();
		if (Browser.Mozilla) ResizeAll();
	}

	function ResizeAll()
	{
		var width = GetWidth();
		if (width < 684)
			width = 684;
		width = width - 30;
		var height = Math.ceil(width/3);
		
		if (prevWidth != width && prevHeight != height) {
			prevWidth = width;
			prevHeight = height;
			plainEditor.style.height = height + ""px"";
			plainEditor.style.width = width + ""px"";
		}
	}

	function ChangeBCCMode()
	{
		if (!bccCont) bccCont = document.getElementById('bcc_cont');
		if (!bccSwitcher) bccSwitcher = document.getElementById('bcc_mode_switcher');
		if (bccMode == 'hide') {
			bccMode = 'show';
			bccCont.className = '';
			bccSwitcher.innerHTML = '" + _resMan.GetString("HideBCC") + @"';
		} else {
			bccMode = 'hide';
			bccCont.className = 'wm_hide';
			bccSwitcher.innerHTML = '" + _resMan.GetString("ShowBCC") + @"';
		}
		return false;
	}

	function LoadAttachmentHandler(attachObj)
	{
		var attachtable = document.getElementById('attachmentTable');
		if (attachObj)
		{
			var imageLink = GetFileParams(attachObj.FileName);
			var tr = attachtable.insertRow(rowIndex++);
			var now = new Date();
			var tempname = now.getTime() + now.getMilliseconds() + '_' + attachObj.TempName;
			tr.id = 'tr_' + tempname;
			var td = tr.insertCell(0);
			td.className = 'wm_attachment';
			var innerHtml = '<img src=\'./images/icons/' + imageLink.image + '\' />';
			innerHtml += '<input type=\'hidden\' name=""attachments[' + attachObj.TempName + ']"" value=\'' + attachObj.FileName + '\'>';
			innerHtml += attachObj.FileName + ' (' + GetFriendlySize(attachObj.Size) + ') <a href=\'#\' id=\'' + tempname + '\' onclick=\'return  DeleteAttach(this.id);\'>' + Lang.Delete + '</a>';
			td.innerHTML = innerHtml;
		}
	}

	function DeleteAttach(idline)
	{
		var trtable = document.getElementById(""tr_"" + idline);
		if (trtable)
		{
			trtable.className = ""wm_hide"";
			CleanNode(trtable);
		}
		return false;
	}

	function addattach()
	{
		if (!hiddenform) hiddenform = CreateChildWithAttrs(document.body, 'form', [['method', 'POST'],['action', 'upload.aspx'], ['target', 'UploadFrame'], ['enctype', 'multipart/form-data'], ['class', 'wm_hide']]);
		var fileinput = document.getElementById('fileupload');
		hiddenform.appendChild(fileinput);
		hiddenform.submit();
		CleanNode(hiddenform);
		CreateChildWithAttrs(document.getElementById('forfile'), 'input', [['type', 'file'],['name', 'fileupload'], ['id', 'fileupload'], ['class', 'wm_file']]);
	}

");
			}

			if (_message != null)
			{
				js.AddInitText(@"SetPriority(" + (int)_message.Priority + ");");
				switch (_action)
				{
					case MessageAction.Forward:
						toTextBox.Value = "";
						subjectTextBox.Value = _resMan.GetString("Fwd") + ": " + _message.Subject.ToString();
						body = Utils.GetMessagePlainReplyToBody(acct, _message);
						break;
					case MessageAction.Reply:
						if(_message.ReplyTo.Count>0)
						{
							foreach(EmailAddress adr in _message.ReplyTo)
								toTextBox.Value += adr.ToString()+",";
							toTextBox.Value=toTextBox.Value.TrimEnd(new char[1]{','});
						}
						else
							toTextBox.Value=_message.From.ToString();

						subjectTextBox.Value = _resMan.GetString("Re") + ": " + _message.Subject.ToString();
						body = Utils.GetMessagePlainReplyToBody(acct, _message);
						break;
					case MessageAction.ReplyAll:
						string tmp_str="";
						if(_message.ReplyTo.Count>0)
						{
							foreach(EmailAddress adr in _message.ReplyTo)
								tmp_str += adr.ToString()+",";
							tmp_str=tmp_str.TrimEnd(new char[1]{','});
						}
						else
							tmp_str=_message.From.ToString();

						js.AddInitText(@"
	document.getElementById('newMessageID_toTextBox').value = ParseEmailStr('" + tmp_str + @"," + _message.To.ToString() + @"," + _message.Cc.ToString() + @"," + _message.Bcc.ToString() + @"', '" + acct.Email + @"');
						");
						subjectTextBox.Value = _resMan.GetString("Re") + ": " + _message.Subject.ToString();
						body = Utils.GetMessagePlainReplyToBody(acct, _message);
					break;
					default:
						body = _message.BodyPlainText;
					break;
				}
				if (_message.HasAttachments && _action == MessageAction.Forward)
				{
					foreach (Attachment attach in _message.Attachments)
					{
						attachmentsHtml += String.Format(@"
<tr id=""tr_{5}"">
		<td class=""wm_attachment""><input type=""hidden"" name=""attachments[{5}]"" value=""{1}""><img src=""{0}""/><span>{1}({2})</span><a href=""{3}"" onClick=""return  DeleteAttach(this.id);"">{4}</a></td>
</tr>",
							Utils.GetAttachmentIconLink(attach), // 0
							Utils.GetShortFilename((attach.Name.Length > 0) ? attach.Name : attach.Filename), // 1
							Utils.GetFriendlySize(attach.Size), // 2
							"#", // 3
							_resMan.GetString("Delete"), // 4
							attach.SavedAs					
							);
					}
				}
			}
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN: This call is required by the ASP.NET Web Form Designer.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		///		Required method for Designer support - do not modify
		///		the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion
	}
}
