using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;

namespace WebMailLite
{
	/// <summary>
	/// Summary description for webmail.
	/// </summary>
	public class webmail : System.Web.UI.Page
	{
		protected WebmailResourceManager _resMan = null;
        protected WebmailSettings settings = null;
		protected string defaultTitle = "AfterLogic WebMail 4.3";
		protected string defaultSkin = Constants.defaultSkinName;
		protected int start = 0;
		protected string to = string.Empty;

		private void Page_Load(object sender, System.EventArgs e)
		{
			if (Request.QueryString.Get("start") != null)
			{
                try
                {
                    start = int.Parse(Request.QueryString.Get("start"));
                }
                catch (ArgumentNullException)
                {
                    start = 0;
                }
                catch (FormatException)
                {
                    start = 0;
                }
                catch (OverflowException)
                {
                    start = 0;
                }
			}
			if (Request.QueryString.Get("to") != null)
			{
                to = Utils.EncodeJsSaveString(Request.QueryString.Get("to"));
			}
			_resMan = (new WebmailResourceManagerCreator()).CreateResourceManager();

			settings = (new WebMailSettingsCreator()).CreateWebMailSettings();
			defaultTitle = Utils.EncodeJsSaveString(settings.SiteName);
			defaultSkin = Utils.EncodeJsSaveString(settings.DefaultSkin);
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN: This call is required by the ASP.NET Web Form Designer.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{    
			this.Load += new System.EventHandler(this.Page_Load);
		}
		#endregion
	}
}
